module Panda.Model.Static where

-- env
import Panda.Helper.Env hiding (match, body)
import Prelude hiding ((.), (/), id, readFile)
import qualified Panda.Config.Global as Config
import Panda.Type.Reader

data Static = Static 
  { uid :: String
  , title :: String
  , body :: String
  , tags :: [String]
  , reader :: Reader
  }
  deriving (Show, Eq)
  
  
get id        = liftM3 (Static id (get_title id) ) (get_body id) (return []) (return $ get_reader id)
get_title     = id_to_resource >>> dropExtension
get_body id   = (Config.flat_uri / id) .readFile
get_reader id = id.take_extension.guess_reader.fromMaybe Config.default_reader


markup x = render_to_html (x.reader) (x.body)